<HTML>
<BODY>

<!-- The first Integration Object in the chain, Callupchain1, issues the callup search given the last name entered on the previous
       page. Notice that Callupchain1 is not explicitly set with the value of "lastName". This is because the Web parameter,
       "lastName", happens to match Callupchain1's input property "lastName". The JSP page compiler generates code which
       looks for such matches and associates Web parameters with input properties as appropriate. Callupchain1 returns the number 
       of hits, or lines, in the resulting "Callup Results" screen by extracting that value from the initial
       search results screen. We use this value to calculate how many pages of names to return. -->
<BEAN NAME="Callupchain1" TYPE="IntegrationObject.Callupchain1" INTROSPECT="yes" CREATE="yes" SCOPE="request">
</BEAN>
<% Callupchain1.setHPubStartPoolName("chainpool"); %>
<% Callupchain1.doHPTransaction(request, response); %>

<% // Using Java code here, calculate the number of pages of names to gather by:
       // 1) first retrieving the number of lines from the output of Callupchain1
       // 2) calculate the number of pages based on the fact that 6 lines always appear per page
       // 3) then add another page if there is a last page of fewer than 6 names
       
       // We extract three characters for the number of lines in the resulting search. If the search
       // returns less than 10, then we'll catch the 'f' in the word "of". We need to remove everything in
       // what was returned up to the actual number of lines, which is separated from everything else
       // by one space, so look for the last space in the results and keep everything after it.
       String numberOfHits = Callupchain1.getNumberOfHits();
       int lastSpace = numberOfHits.lastIndexOf(' ');
       if (lastSpace != -1) numberOfHits = numberOfHits.substring(lastSpace+1);    

       int numLines = new Integer(numberOfHits.trim()).intValue();
       int numPages = numLines / 6;
       if ((numLines % 6) > 0) numPages++; %>

<BEAN NAME="Callupchain2" TYPE="IntegrationObject.Callupchain2" INTROSPECT="yes" CREATE="yes" SCOPE="request">
</BEAN>


<FORM METHOD="POST" ACTION="<%= response.encodeUrl("manager.jsp") %>">

<P>Select one of the names from the results: 
<SELECT NAME ="indexValue" MULTIPLE SIZE=3> 
<% int index = 0; 
       String name = new String();
       // Loop through the number of pages of results. Each loop calls Callupchain2 to extract one page's worth of
       // names, then page down once. The last loop will get the last screen and the last page down will return the
       // screen to the first page of names (since page down will eventually loop to the first screen). We add to the
       // end of the list box every time we run Callupchain2 to do its work. Callupchain2 picks up where Callupchain1
       // ends, which is on the initial callup search results screen.
       for (int i = 0; i< numPages; i++)
       {
           // run Callupchain2 to process the first screen and page down
          Callupchain2.doHPTransaction(request, response); %>
          <REPEAT index=idx1>
          <%  // The REPEAT tag loops through all values from this pass of Callupchain2, which should
                  // be at most 7 (six names and one blank line at the end, which I failed to take into account when
                  // creating the extract.
                  //
                  // Store the current name (indexed by idx1 from the REPEAT tag) into a String variable. Strip off
                  // leading and trailing blanks
                  name = Callupchain2.getExtractResultsname(idx1).trim();
                  // If the name is empty, then ignore this line (it's a blank line we accidentally captured
                  if (name != null && !name.equals(""))
                  {
                      // Add this name into the listbox. Give its index in the listbox as its associated value. We 
                      // increment the index every time we add a new line to the listbox (index++).
                      index++;
                      String str = "<OPTION VALUE=\"" +index + "\">\n"; out.println(str); %>
                      <INSERT BEAN=Callupchain2 PROPERTY = extractResultsname></INSERT>
                      </OPTION>
           <% }    %>
          </REPEAT> 
<%  } %>

<!-- This page will show the list of names retrieved as a result of running the query. The user must then select one
       of the names to then show his/her manager. This FORM will send the index of the name selected in the variable
       indexValue (specified in the SELECT tag above) as a web parameter to the next page (manager.jsp). -->
 </SELECT>
<P><INPUT TYPE="submit" VALUE="Submit">
</FORM>
</BODY>
<% out.close(); %>
</HTML>